package com.agiledeveloper;

import rx.Observable;
import rx.Subscriber;

import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

public class MovieServer {
  public Observable<String> getDirectors(final List<String> movieNames) {
    return Observable.create(
        new Observable.OnSubscribe<String>() {
          @Override
          public void call(final Subscriber<? super String> subscriber) {
            pushMovieInfo(subscriber, movieNames);
          }
        });
  }

  private void pushMovieInfo(Subscriber<? super String> subscriber, List<String> movieNames) {
    for (String movieName : movieNames) {
      String director = MovieInfo.getMovieInfo(movieName).get("Director");
      if(director == null)
        subscriber.onError(new Throwable(movieName + "? learn typing dude :)"));
      subscriber.onNext(movieName + "---" + director);
    }

    subscriber.onCompleted();
  }
}